/* generate .tap file for soliyawn
 * usage: ./maketap <soliyawn.bin >soliyawn.tap
 *
 * PD by RJM
 */

#include <stdio.h>

/* most of an auto-running .tap file containing the program below:
 *
 * 1 randomize:randomize usr peek val "23773":rem [...]
 *
 * This is the file up to and including the `rem' token.
 */

unsigned char tapstart[]=
  {
  0x13, 0x00, 0x00, 0x00,
  's',  'o',  'l',  'i',
  'y',  'a',  'w',  'n',
  0x20, 0x20, 0x00, 0x00,
  0x01, 0x00, 0x00, 0x00,
  0x4E, 0x16, 0x00, 0xFF,
  0x00, 0x01, 0x10, 0x00,
  0xF9, 0x3A, 0xF9, 0xC0,
  0xB0, 0x22, 0x32, 0x33,
  0x37, 0x37, 0x33, 0x22,
  0x3A, 0xEA
  };


int main(void)
{
int f,check_byte;
unsigned char buf[2048];
int codelen;
int baslen;

codelen=fread(buf,1,sizeof(buf),stdin);
buf[codelen]=0x0d;
codelen++;
baslen=codelen+sizeof(tapstart)-24;

tapstart[14]=tapstart[18]=baslen%256;
tapstart[15]=tapstart[19]=baslen/256;
tapstart[21]=(baslen+2)%256;
tapstart[22]=(baslen+2)/256;
tapstart[26]=(baslen-4)%256;
tapstart[27]=(baslen-4)/256;

check_byte=0;
for(f=3;f<20;f++)
  check_byte^=tapstart[f];
tapstart[20]=check_byte;

fwrite(tapstart,1,sizeof(tapstart),stdout);

check_byte=0xff;
for(f=24;f<sizeof(tapstart);f++)
  check_byte^=tapstart[f];

for(f=0;f<codelen;f++)
  {
  putchar(buf[f]);
  check_byte^=buf[f];
  }

putchar(check_byte);

exit(0);
}
